let tab = new function() {
	let self = this,
		tabs = null,
		container = null,
		nav = null;
	
	self.init = function(){
		container = document.querySelector(".nav-bar");
		nav = document.createElement('ul');
		container.appendChild(nav);
		$tabs = $(container).tabs();

		let btn = createWrapper("ui-state-default ui-corner-top option-add-tab");
		let anchor = document.createElement('a');
		anchor.setAttribute("href", "javascript:void(0);");
		anchor.className = "ui-tabs-anchor";
		let span = document.createElement('span');
		span.appendChild(document.createTextNode("✛"));

		anchor.onclick = function(){
			self.add('Tab', 'Lorem Ipsum is simply dummy text ...');
		}

		anchor.appendChild(span);
		btn.appendChild(anchor);

		nav.appendChild(btn);
	}

	self.add = function(title, content){
		let numItem = nav.getElementsByTagName("li");
		let id = "tabs-" + (numItem.length + 1);		

		nav.insertBefore(self.createUINav(title, id, function(element, event){
			self.remove(element, id, event);
		}), nav.lastChild);

		let panel = document.createElement('div');
		panel.setAttribute("id", id);
		container.appendChild(panel);

		$tabs.tabs("refresh");
		$tabs.tabs({active: numItem.length - 1});
		
		panel.insertBefore(self.createSection(content, panel.getAttribute("aria-labelledby")), panel.firstChild);

		return panel;
	}
	
	self.remove = function(element, event){
		let id = element.getAttribute("aria-controls");
		let selectedTab = element.classList.contains('ui-tabs-active')? true : false;
		element.parentNode.removeChild(element);

		if (node = document.getElementById(id)){
			node.parentNode.removeChild(node);
		}

		let items = nav.querySelectorAll('a[role]'); 
		$(items).removeUniqueId();

		let panels = container.querySelectorAll(":scope > div");

		for (let i = 0; i < items.length; i++) {
			let id = $(items[i]).uniqueId().attr( "id" );
			let num = i + 1;
			items[i].setAttribute("href", `#bar-menu-tabs-${num}`);
			items[i].parentNode.setAttribute("aria-labelledby", id);
			if (panels[i]){
				panels[i].setAttribute("id", `bar-menu-tabs-${num}`);
				panels[i].setAttribute("aria-labelledby", id);
			}
		}

		$tabs.tabs("refresh");

		if (selectedTab) {
			$tabs.tabs({active: 0});
		}
	}
	
	self.createSection = function(title, id){
		let element = createWrapper("tabs_name-section"),
		span = document.createElement('span');
		element.setAttribute("aria-labelledby", id);
		span.appendChild(document.createTextNode(title));
		element.appendChild(span);

		return element;
	}
	
	self.createUINav = function(title, id, callback){
		let element = document.createElement('li');
		let anchor = document.createElement('a');
		let span = document.createElement('span');
		anchor.setAttribute("href", `#${id}`);
		span.appendChild(document.createTextNode(title));
		anchor.appendChild(span);
		
		let elm = document.createElement('span');
		elm.className = "option-delete-tab";
		elm.appendChild(document.createTextNode("✖"));
		elm.onclick = function(event) {callback(element, event)};
		anchor.appendChild(elm);

		element.appendChild(anchor);

		return element;
	}
}

document.addEventListener("DOMContentLoaded", function(event) {
	tab.init();
});

	


function createWrapper(className) {
    let wrapper = document.createElement('div');
    wrapper.className = className;

    return wrapper;	
}